module.exports = {
  parser: "@typescript-eslint/parser", // Specifies the ESLint parser
  extends: ["prettier"],
  plugins: [
    "@typescript-eslint", 
    "prettier",
  ],
  parserOptions: {
    ecmaVersion: 2018, // Allows for the parsing of modern ECMAScript features
    sourceType: "module" // Allows for the use of imports
  },
  ignorePatterns: ["dist/", "node_modules/"],
  rules: {
    "@typescript-eslint/no-unused-vars":  ["error", { "argsIgnorePattern": "^_" }],
    "linebreak-style": ["error", "unix"],
    "no-var": "error",
    "arrow-body-style": [0],
    "no-param-reassign": [2],
    "prefer-template": [2],
    "prettier/prettier": ["error"]
  },
  
};