require('dotenv').config();
import { mainQueue } from './queue';
import { JOB } from './constants';
import { Queue } from 'bull';

function attachListener(jobName: string, queue: Queue = mainQueue) {
  const fileName = `${__dirname}/handlers/${jobName}.js`;
  queue.process(jobName, fileName);
}

attachListener(JOB.HEARTBEAT);
attachListener(JOB.FETCH_MEALS);
attachListener(JOB.SUGGEST_TO_EVERYONE);
attachListener(JOB.ADD_FETCH_JOBS);

mainQueue.on('completed', (job, result) => {
  console.log(`${job.name} OK: ${JSON.stringify(result)}`);
});

mainQueue.on('failed', (job, err) => {
  console.log(`${job.name} (${job.id}) FAILED: ${JSON.stringify(err.message)}`);
  console.error(err);
});
