# Päevapakkumiste soovitussüsteem (pp-classifier)

Lunch offers recommendation system readme document. This document explains the contents of the files and how to run the application locally.

## Architecture

The source code of the application is in the /src directory.

### /src directory

- `Classifier.py` - defines the `Lemmatizer` class, which is responsible for preprocessing and finding the lemmas, and the `Classifier` class, which is responsible for finding the features of meals.
- `Recommender.py` - defines the `Recommender` class, which is responsible for calculating and ordering meals by their score for the users. 
- `Meal.py` - defines a Meal class, which is used as a data model in `Classifier.py`.
- `main.py` - this is the entry point of the application, which defines the endpoints and handles requests.

### root directory

- `.gitignore` - contains pathname patterns that need to be excluded from the repository.
- `CHECKS` - this file defines an endpoint that [Dokku](http://dokku.viewdocs.io/dokku/) can use to verify that the deploy was successful and the application is running. This is used for [zero downtime deploys](http://dokku.viewdocs.io/dokku/deployment/zero-downtime-deploys/).
- `Dockerfile` - specifies the [instructions for Docker](https://docs.docker.com/engine/reference/builder/) on how to build the container and run the application. Dokku builds and runs the container on deploy.
- `environment.yml` - [conda environment](https://docs.conda.io/projects/conda/en/latest/user-guide/concepts/environments.html) file, which holds the dependencies to be installed by [conda](https://docs.conda.io/en/latest/).
- `runfirst.py` - this file is used in Dockerfile build layer, to download estnltk data which will be cached in this layer. This speeds up build times. You can read more [here](https://docs.docker.com/develop/develop-images/dockerfile_best-practices/).

## Development

You do not need docker to develop this application.

- You need the [conda package manager](https://www.anaconda.com/).
- Then you can create the conda environment from the `environment.yml` file by running the following in the command line: 
```
conda env create -f environment.yml
```
- Then you must activate the environment
```
conda activate env35
```
- I suggest changing `debug=True` in `main.py` file `app.run` function. Then it will restart the server when files have changed.
- Now you can start the application locally
```
python src/main.py
```
