class Meal:
    def __init__(self, id, description):
        self.id = id
        self.description = description

        self.lemmatizer = None
        self.lemmas = None
        self.brackets = None
        
        self.classifier = None
        self.category = None
        self.meat = None
        self.vegetarian = None
        self.ingredients = None

        self.error = None
    def lemmatize(self, lemmatizer):
        self.lemmatizer = lemmatizer
        lemmatizer.lemmatize(self)
        return self
    def classify(self, classifier):
        self.classifier = classifier
        classifier.classify(self)
        return self 
    def toDict(self):
        if self.error:
            return {
                "id": self.id,
                "description": self.description,

                "error": True,
                "message": str(self.error),
                "type": str(type(self.error))
            }
        
        return {
            "id": self.id,
            "description": self.description,

            "lemmas": self.lemmas,
            "brackets": self.brackets,
            
            "classifier": self.classifier.name,
            "category": self.category,
            "meat": self.meat,
            "vegetarian": self.vegetarian,
            "ingredients": self.ingredients,
        }